This is an addendum to CAL14S24.ZIP and contains a new version of CALLS.EXE
which addresses the problems or new features listed below. A sample CALLS.CNF
is also included as several new entries have been added.

Problems:

1:  With the new feature of PCBoard 14.5a that allows single character Door
    names, CALLS.EXE locks up.

    Fixed the routine that found the Door name and stripped off the path
    information.

2:  Non ANSI callers were ignored (those with (A) in the log), only (N) & (G)
    graphics modes were being recognized.

    Added Non ANSI as graphics mode (A) so now all three modes are reported.

3:  Sysop sessions were ignored when PCBoard was setup to use the Sysops true
    name instead of just SYSOP.

    Added SYSOPNAME option to config file to allow recognizing the Sysop
    in the caller log when the full name is used instead of SYSOP. If not
    given the default is SYSOP.

4:  Average Event Length always showed ZERO for my board, as the first event
    activity was RNET which writes entries to the log that duplicate a User
    logon and CALLS.EXE considers the Event to end the first caller entry.
    This also causes problems that the Event does not terminate timing until
    a caller logs on and this does not reflect event duration properly.

    Added support for RNET that causes CALLS to not stop timing an event if
    it sees the FirstName is RNET.EXE. Also Added EXCLUDENAME to allow skipping
    another program like RNET.EXE that appears to log on as a User in the log.
    If the first name of the User matches the EXCLUDENAME it is skipped.
    (Also now allowed to specify up to 10 EXCLUDENAME entries)

    Added the recognition of the line:

       Scheduled Event ended at MM-DD-YY HH:MM:SS

    to properly end the event time calculations rather than continuing time
    until a caller logs on. This entry can be created by using a utility to
    write lines to callers log. (Like my CL-PRINT.COM program.)
    Note: PCBoard 15.0 now adds this line already.

    Added Event program report. Using the line

       Event: program name started at MM-DD-YY HH:MM:SS

    will begin the timing of an event program. Timing will end when another
    line starting with 'Event: ' is detected, the Scheduled Event ended line
    is detected or a User logon is deteced. The Number of times each program
    is executed and total time is tracked and a report of Average time is
    generated.

                       -= Average Event Program Times =-

                 Norton Speed Disk:     5 Times    31.6 Min Avg.
                            Backup:     5 Times    10.6 Min Avg.
                           PCBFile:     5 Times     6.2 Min Avg.
                     Call Analyzer:     5 Times     1.6 Min Avg.

5.  Connect Type Report is not working.

    Added recognition of 'Modem:' as connect type for PCBoard 14.x
    compatability.

    Added RINGFILTER ON/OFF to control removal of RING from CONNECT type
    report. Also removes any additional text after the CONNECT XXXXXXXXX
    message.

6.  Batch Size Report is not working. (FREE Downloads also not working)

    PCBoard 14.5a now supplies Batch transfer report, added support for
    the format of this data so that this report now works.

    PCBoard does not flag FREE or NO TIME Downloads in any way in the
    caller log so this report can not 'easily' be made to work. The
    amount of time the report would spend attempting to decide if a file
    was FREE or not would not be worth it. If future versions of PCBoard
    do note this in the caller log, I will get this report to work.

7.  PCBVerify's report of "XXX-XXX-XXXX Added to trashcan" causes security
    violation counts.

    Fixed.

8.  Sysop paged after hours, not counted.

    Created seperate counter for this, along with report of Chat Time.
    Added Node chat also

    Added CHATMODE and NODEMODE which operate similar to EVENTMODE but
    control Sysop Chat and Node Chat timing. But I recommend that they be
    set to IDLE in most cases, Unless you find they need to be changed.

9.  Messages left count did not include RNET imported messages, ZIPM
    messages showed import & export count.

    Made RNET import messages show in messages left count and also in
    ZIPM (changed name to MAIL) count. RNET import counts as MAIL
    executed.

10. Log off scripts did not count in Scripts Completed.

    Made seperate counter for this.

13. Added configuration variable REPORTTYPE to control output generated.
    ASCII will generate non-color version, ANSI will generate 'G' color
    version, and BOTH will generate both (Default).

    Added ReportType of PCBOARD to generate a single outputfile using
    PCBoard @Xnn color codes

12. Added additional reports of Users who leave messages and Which Conference
    is getting message traffic.

    Added MAXMSGS & MAXUSERS to control new reports of Conference Messages
    Left & User Messages Left

13. Added additional reports for reasons logged off and security violations.

Added Sysop Statistics 'S' report

  Sysop Local Sessions...       x         Node Chats Initiated...       x
  Sysop Remote Sessions..       x         Node Chat Time (min)...       x
  Remote DOS Time (min)..       x         Sysop Chats Initiated..       x
  Remote Drops to DOS....       x         Sysop Chat Time (min)..       x
  SHELL Executed.........       x         Sysop Paged............       x
  Text Files Viewed......       x         Sysop Paged after Hours       x
  Caller log Viewed......       x         Temporary Sysop Priv...       x
  User File Viewed.......       x         Node Forced to DOS.....       x

Added User Statistics 'R' report

  Protocol Changes.......       x         Expert mode Toggled....       x
  User Record Updates....       x         Graphic Mode Toggled...       x
  Language Changes.......       x         Page Length Changes....       x


Changed Security Statistics 'N' report

  Automatic Lockouts.....       x         Security Violations....       x
  Trashcan Names.........       x         Incorrect Password.....       x
  Excessive Passwords....       x         Password Failures......       x
  Excessive Command Errs.       x         Remote Password Failure       x
  Refused Registration...       x         Non-Registered Users...       x
  Time Limit Expired.....       x         Not Registered in Conf.       x
  Keyboard Timeouts......       x         Dropped Carrier........       x
  Insufficient D/L Time..       x         Dropped Carrier in Door       x
  Insufficient Bytes/File       x         Missing Level in PWRD..       x
  Automatic Disconnects..       x         Door Selected UnAvail..       x
  Closed Board/Node......       x         Event Time Clash.......       x
  Multi-Node Login.......       x         Typo Errors............       x
  Attempted Alias Logon..       x         System Errors..........       x

Moved Scheduled Event & Event Time and Added Logoff Scripts Completed
to Systems Statistic 'A' report.

  Directory Scans........       x         Total Messages Left....       x
  Doors Opened...........       x           Comments Left........       x
    Time spent in Doors..   xx:xx           PCBoard Messages.....       x
  Downloads Completed....       x           MailDoor Messages....       x
    Different Files......       x           Net MAIL Messages....       x
    Downloads Aborted....       x           Net MAIL Executed....       x
    Free Downloads.......       x         Number of Callers......       x
  REPACK Executed........       x           New Users Registered.       x
  TEST Executed..........       x           Ave. Calls Per Day...     x.x
  Uploads Completed......       x           Ave. Call Duration...     x.x
    Bad Uploads Deleted..       x           Ave. Idle Time.......     x.x
    Uploads Aborted......       x         Scripts Completed......       x
  VIEW Executed..........       x         Logoff Script Completed       x
    Members Extracted....       x         Total Operation Hours..     x.x
    Members Viewed.......       x           Utilization Hours....     x.x
  Scheduled Events.......       x           Total Utilization %..     x.x
  Ave Event Length (min).     x.x           Peak Utilization %...     x.x
  LIB Executed...........       x         Time System locked up..     x.x

14. Fixed problem with security levels being duplicated in .SAV file due to
    spaces stripped off of first entry only.

15. Changed output structure of fileames in .SAV file to save space.

16. Added Language report by placing Language Number in Modem connect string
        ie. Modem (1): CONNECT 2400
    or Caller Number string
        ie. Caller Number (1): 12345
    or Security Level string
        ie. Caller Security (1): 50

    This is accomplished by using MKTXT145 to modify the record for the
    'Modem: @OPTEXT@' (rec no 590), 'Caller Number: @OPTEXT@' (rec no 591)
    or 'Caller Security: @OPTEXT@' (rec no 592) and adding the text (n) to
    the current text as shown above (where n is the language number, ie.
    for your first language you add (1), for your second language PCBTEXT
    file you add (2), etc...)

17. Found limitation in graph routines that limited lists to 100 items, which
    caused loss of many Names, Conference Bulletins, Conferences joined if
    any list execeed that number of items, incresed limit to 500 which should
    be sufficient for most systems, if not change the const (graph_num).

18. Added FILENAMES to control the saving of filenames and Counts to the
    History File.

19. Added FILTERFILE Masks to allow filtering filenames from report and
    history file. Wildcards are allowed and a special '#' wildcard will
    match another '#' or a digit ('0' - '9') to aid in filtering capture
    file downloads (#####?.ZIP and #####?.CAP).

20. Allowed for 10 EXCLUDENAME Entries & 50 FILTERFILE Masks Entries

21. Added Last-On Report, requires using program like CL-PRINT V2.0 to
    write a line to the CALLER log file in the format of

    Last On: MM-DD-YY (HH:MM)
    or
    Last On: MM-DD-YY (HH:MM) for nn Minute(s)
    or
    Last On: MM-DD-YY (HH:MM) for nn Minute(s) - #nnnn

    The report format look like this:

                            -= Last Called In =-

     Within One Week:   129 (19.9%) 
        Previous Day:   112 (17.3%) 
            Same Day:    99 (15.3%) 
    Within Two Weeks:    36 ( 5.5%) 
    Within One Month:    32 ( 4.9%) 
           New Users:    24 ( 3.7%) 
   Within Two Months:    16 ( 2.5%) 
  Within Four Months:    12 ( 1.8%) 
   Within Six Months:    10 ( 1.5%) 
  Within Nine Months:     4 ( 0.6%) 
    Within Two Years:     4 ( 0.6%) 
  Within Three Years:     1 ( 0.2%) 
     Within One Year:     1 ( 0.2%) 


    Example:

    CL-PRINT C:\PCB\MAIN\CALLER /Q,/S,"Last On: @D (@T)"
    or
    CL-PRINT C:\PCB\MAIN\CALLER /Q,/Z,/S,"Last On: @D (@T) for @M Minute(s)"
    or
    CL-PRINT C:\PCB\MAIN\CALLER "/Q/Z/SLast On: @D (@T) for @M Minute(s) - #@#"

    This example can be run in your $$LOGON.BAT

NOTE: SHARE must be loaded if you intend to write to the CALLER log during
      $$LOGON.BAT or $$LOGON.BAT as PCBoard has the file open and has written
      entries to it prior to calling the batch files. If SHARE is not loaded
      you will write over the top of the entries PCBoard has made. Also,
      this can only be done on Network verisons /E & /U and you CAN NOT
      use it on /D or /S versions as PCBoard has the USERS file open in
      DENY READ/WRITE on these versions, so the file can not be opened by
      CL-PRINT to obtain the information desired.

Note: for PCBoard 15.0 you can use the enclosed LASTON.PPE to write this
      line into the log.


22. Changed files downloaded report to not generate an ANSI sequence when
    there is no change in color.

23. Added more support for Southern Style & Three Stooges Language file
    entries in CALLERS log.

24. Added CATCHALLREPORT Variable to log text lines passing thru the
    Catchall routine to assist in changing the line parsing routines.

25. Added MAIL Door support. QMail, MarkMail & Cam-Mail entries are all
    recognized and a seperate report for each Mail Door is supported.
    All three reports are the same and the titles can be changed to
    anything so if it works for other mail doors you now have a report.
    (If it does'nt work, send some sample caller log entries to me and
    I will try to add support, I might add control over which entries
    are printed so those which are not applicable to a particular door
    can be skipped).

26. Added support for a few junk entries (like CALLER NUMBER:) to speed up
    report by recognizing the entry sooner. And to support imbedding the
    Language number in Caller Number as well. (See item #16 above)

27. Added support and a report for a User Definable Door. (Door U / Y8)
    Text to be scanned for may be defined (up to 20 variables) and
    The Text to be used in the Report may be defined. Undefined variables
    will not be scanned for or reported. Special handling is defined for
    entries that would indicate the Door logged the caller off, and
    entries which should not be counted if the Door logged the User off.
    (this allows for not counting CARRIER LOST as a User Hang up if it
    was the door that dropped carrier.)  Also printing '...' or blank
    entries in the report to allow lining up report when skipping variables
    or using an odd number of variables. Count of times Door used and
    logging off in door and Time Spent in Door are always reported for
    the Door, so no special handling for this is needed.

28. Added changes from CAL14S22.ZIP & CAL14S23.ZIP to this release.

29. Added Message Statistic '#' Report.

                          -= Message Statistics =-

  Messages Left..........       x         MailDoor Messages......       x
         Via PCBoard.....    xx.x%               Via Mail Doors..    xx.x%
    Comments Left........       x           Net MAIL Messages....       x
         Via COMMENT.....    xx.x%               Via Mail Import.    xx.x%
    Messages Moved.......       x           Net MAIL Executed....       x
    Messages Copied......       x           Mail Packets DLed....       x
    Messages Restored....       x                        Aborted.       x
    Messages Deleted.....       x           Reply Packets Uled...       x
  Message Entry Aborted..       x                        Aborted.       x
  Message Base Packed....       x         No Room for text.......       x

30. Added SECLABEL variable to define text to be added to Security Level
    reports, and NOSECLABEL variable to define text for no level.

31. Corrected Door timing routines to properly time a Door when User
    Logged off in Door and a Back From Dos entry did not exist. If
    you Run PCBVerify (or some other Door from your InstaReg batch
    file, instead of returning to the BBS first, you can use CL-PRINT
    to insert a line:

    Opened Door (VERIFY) at HH:MM Via InstaReg

    ie.

    CL-PRINT C:\PCB\MAIN\CALLER /Q,/S,"Opened Door (VERIFY) at /T Via InstaReg"

    This will cause CALLS to stop timing the InstaReg Door and start
    timing the new Door (ie. VERIFY) and accumlate the information on
    the proper Door.

32. Changed report format for many of the Doors to make them consistent
    with one another and to add a couple of entries.

33. Added seperate reports for Hangups in Board & in Doors.

34. Added support for PCBVerify 4.0 message changes and minor changes to
    Report for PCBVerify  (VERIFY & CALLBACK)

35. Removed GENERIC & DEFDOORTITLE and replaced with REPORTTITLE to define
    label for any of the report sections

36. Added Report control characters for REPORTS definition
    Z - insert a blank line          . - do nothing character
    @ - insert a @MORE@ prompt       $ - insert a @PAUSE@ prompt
    % - insert a @WAIT@ prompt       * - insert a @CLS@
    if * is first character then a @CLS@ (or ANSI clear screen) will be
    sent at the beginning of bulletin.

37. Added REPORTACTION variable which can be defined with any of the above
    characters. These characters will be used to send strings after EVERY
    report section.   If any of the above characters are included after a
    report directly in REPORTS, then the REPORTACTION will not be sent after
    that report allowing override of REPORTACTION to combine a couple of the
    shorter reports to a single screen.

38. Added a SHORTENGRAPH variable to the .CNF file that will cause the
    Hourly Usage graph to start at the highest used percentage instead
    of at 100% if desired. If a numeric value is used (0 to 100 by 5's
    then that will be the starting point if the highest percentage is
    below that). ie if the highest used percentage was 40 then the graph
    would start at NO = 100%, YES = 40%, 60 = 60%, 20 = 40%.

39. Added a REFUSEDREG variable that combines the Non-Registered value to
    the Refused to Register value in the report. When running your board
    to allow Users to remain on (a non-zero security level assigned to
    those who refuse to register), those Users will show up as Non-Registered
    Users and only those who give a partial name and then refuse to give a
    full name will show up as Refused to Register. If REFUSEDREG is set to
    YES, then both will be combined and reported under Refused to Register
    (although Non-Registered will still be reported). If you set a zero
    security level to those who refuse to register, there shoud be No
    Non-Registered Users reported as PCBoard kicks them off and issues the
    ACCESS DENIED - REFUSED TO REGISTER to the callers log, and I don't think
    will ever use the REFUSED TO REGISTER entry. I had the two backwards in
    previous releases, so some confusion existed.

40. Added LANGUAGE n Text variables to allow defining the name of the
    Languages instead of just the number as before. You can include
    the number in the text as in the example .CNF file. If not defined
    they now default to 'Language 1' etc....

41. Added REPORTEXCLUDE which causes the graph items not to be accumulated
    which can shorten the SAVE file considerably if there are items you
    don't use in your report. The allowable entries are (CEFLOPQRUVWXY!=^-)
    and any other entries will just be ignored.

42. Added report for User Uploads (and a MAXUL setting).

43. Added report for Callers Hanging Up (and a MAXHANGUP setting)

44. Changed the DoorTime reports to HH:MM format from Minutes.

45. Changed all reports to allow for an extra digit in reports as some
    values were exceeding columns when accumulating data for a full year.

46. A few reorganizations in the code as it was starting to exceed code
    segment limitations. (no external appearence changes). Moved some
    of the conversion routines into a seperate UNIT.

47. Color of 'Period covered:' text changed from BLUE to CYAN for better
    readability on most systems.

48. Well, leap year came around and showed me another problem. Fixed the
    month to day calculations to account for leap year. This should keep
    things correct for awhile.

49. Added an EXCLUDEUSER which functions like EXCLUDENAME except it will
    allow excluding a list of Users from the Message Left, Upload &
    Caller Hanging Up reports.

50. Fixed UserName routine to pickup users with more then two names (ie.
    those users who use middle initials, etc...). Name now ends two chars
    before the '(' in the baud rate.

51. Added HEADER variable to define a HeaderFile to be read and written to
    the report prior to writing the report. If you include a '*' as the
    first character of REPORTS as indicated in item 36 above, then the
    @CLS@ (or <ESC>[2J) will be written before the HeaderFile data. Of course
    you could just include this @CLS@ in your header file text. If you use
    the ANSI output (or BOTH) then a 'G' will be added to the filename
    given in HEADER and that will be used for the 'G' version of the output.

52. Found a small problem in the RingFilter routine that allowed extra
    characters to be allowed into the report. Also forgot to add the
    entry to the sample .CNF file.    (see item 6 about Ringfilter)

53. Added EXCLUDEDOOR to allow excluding door names from reports. Up to
    50 door names are provided for.  Added NONDOORNAME to allow defining
    the label used when reporting excluded doors. All excluded doors are
    counted and timed under this label and if the label is set to a blank
    the they will not be reported at all (or added to the save file).

54. Added Caller ID '!' Report.

                         -= Caller ID Statistics =-

  Local Call ID:     6 (37.5%) 
   Outside Area:     4 (25.0%) 
    Private Num:     2 (12.5%) 
       ID Error:     2 (12.5%) 
   Long Dist ID:     2 (12.5%) 


   The Long Dist ID will probably not show up as most Caller ID services do
   not yet show calls from outside the local calling area, but provisions
   have been made just in case the services are expanded on. Most long
   distance calls will show up under Outside Area heading.

   The report requires that an entry be added to the CALLER log file in the
   format:

      CallerID: MM/DD  HH:MM  (AAA)EEE-NNNN G
      CallerID: MM/DD  HH:MM   OUTSIDE call G
      CallerID: MM/DD  HH:MM   PRIVATE call G
      CallerID: MM/DD  HH:MM   E            B

   which should be compatible with most Caller ID services, if you have a
   different format that needs support, get me a message with the format
   and I will add support for it.

55. Added ITEMLEN variable. This controls the length that will be used of a
    graph item. This allows reducing the wasted space on the shorter reports
    and increasing the length of the graph bars themselves. It also allows
    increasing the defaults so the entire User Name would show if one exceeds
    the 20 character limit normally set in CALLS.

56. Added ITEMMAX variable. This controls the maximum length that will be used
    of a graph item when an ITEMLEN of -1 is specified for a report.

57. Added CONNECTFILTER variable. Some modems return much longer Connect
    strings and CALLS truncates the string making it less readable. Setting
    CONNECTFILTER to ON causes the word CONNECT to be eliminated from the
    string, allowing more room for useful text. If the string contains only
    the word CONNECT then it will not be removed. Also improved routine to
    remove the word CARRIER if both CARRIER and CONNECT are present and to
    remove the CONNECT rate as well as the word CONNECT when CARRIER is
    also present.

58. Changed message statistics report to include percentages for COMMENTS and
    Net Mail messages. Also stopped adding Net Mail messages into the count of
    messages left via PCBoard. Changed message reporting in System Statistics
    to show Total of all messages and the four sub-totals.

59. Added ability to Define an EXCLUDEUSER as a NetUser by including an
    '*' as FIRST character of UserName. This will cause messages left by
    this User to count as Net Mail instead of Mail Door messages. If NetUser
    is flagged and a message is left via PCBoard instead of a Door then the
    User Name will NOT be excluded and it will not count as Net Mail.
    Messages left will still show under Door report.

60. Found Confernence names limited to first characters of A-Z and 0-9.
    Removed restrictions altogether.

61. Added support for KMail & Net Mail Doors. All Net Mail Door messages count
    as Net Mail and messages will not be counted as from User in the Top
    User Message section without need for including User Name via EXCLUDEUSER.
    Messages left will still show under Door report.

62. Changed MarkMail message counting. Now adds conference totals on each
    message as before but does not add these to Door totals for MarkMail.
    Adds total from 'Inserted Messages: xxx  Dupes Killed: xxx' line
    so it will work with Short or Long logging format of MarkMail.

63. Added NODELIST parameter to allow specifying the order of processing the
    CALLER logs for multi-node. You may arrange the nodes processed in any
    order you wish by specifing the node numbers in this list seperated by
    spaces. Set NODES to the number of nodes you place in the list. This
    means on a 9 Node setup you could specify NODES 5 and NODELIST 6 7 2 4 1
    and only those 5 nodes would be reported on. If no list is provided then
    all nodes from 1 to NODES will be scanned as before.

64. Found CALLS could still write a blank line for a User name during one
    of the reports into the CALLS.SAV which would then produce an error when
    an attempt was made to re-read the file. Fixed this for good (I hope).

65. Expanded the Last called report to include 2,3,4 & 5 days instead of
    grouping them into the 'within one week'.

66. Changed File pointer to longint allowing proper reading of larger files.

67. Added TextatUrec to narrow down text match to text beginning at seventh
    character, instead of anywhere as in TextinUrec which sould stop some
    conferences with the word MODEM in them from counting as CONNECT messages
    and proabably some other misc. matches from occurring.

68. Fixed openfile procedure to properly skip a CALLER file that does not
    exist rather than stopping with an error.

69. Found a problem when a line of 62 '-' is written to the log (by what I
    don't know) as a '-' in the 3rd position is an indication of a caller
    logging on or off and was used to track time. Made the code check also
    in postion 13 for a ':' to verify the entry.

70. Added EXCLUDECONFERENCE and EXCLUDESECLEVEL to filter out conferences
    and User Security Levels from reports.

71. Found a problem with PCBVerify MODEM RETURNED statements causing junk
    entries 'hh:mm)' in the Connect Report if the door was executed under
    an undefined name or as part of InstaReg, etc. Modified the parsing
    routine to reject these entries.

72. Added SWOP & VOTER PLUS Door reports.  Changed several of the text
    entries searched for to enable better detection of a couple of other
    language files being used.

73. Added DOORJUNKREPORT to control writing Junk, Catchall, and Unknown
    lines to file while in a Door. If not in a Door then JUNKREPORT,
    CATCHALLREPORT and UNKNOWNREPORT control the writing of the lines.

74. Added UNKNOWNDOORREPORT to control writing all lines of Door activity
    to UNKNOWN.TXT file if door is not one of the doors known to CALLS.

    Also added KNOWNDOORS to control writing of Door lines to UNKNOWN.TXT
    when UNKOWNDOORREPORT is set to YES, Doors listed will not be written.

75. Broke up System Statistics and added File Transfer Statistics '+' Report
    instead. Added Upload Credit report and several other items to reports.

                     -= System Statistics for x days =-

  Total Messages Left....       x         Number of Callers......       x
    Comments Left........       x           New Users Registered.       x
    PCBoard Messages.....       x           Ave. Calls Per Day...     x.x
    MailDoor Messages....       x           Ave. Call Duration...     x.x
    Net MAIL Messages....       x           Ave. Idle Time.......     x.x
    Net MAIL Executed....       x         Scripts Completed......       x
  Directory Scans........       x         Logoff Script Completed       x
  Downloads Completed....       x         Total Operation Hours..     x.x
  Uploads Completed......       x           Utilization Hours....     x.x
  Doors Opened...........       x           Total Utilization %..     x.x
    Time spent in Doors..   hh:mm           Peak Utilization %...     x.x
  Scheduled Events.......       x         Time System locked up..     x.x
  Ave Event Length (min).     x.x

                            -= File Transfers =-

  Downloads Completed....       x         Uploads Completed......       x
    Different Files......       x           Bad Uploads Deleted..       x
    Downloads Aborted....       x           Uploads Aborted......       x
    Free Downloads.......       x           Uploads Rejected.....       x
    File not found.......       x           Duplicate Rejected...       x
  VIEW Executed..........       x         Upload Credits issued..       x
    Members Extracted....       x           Upload Time Credit...       x Mins.
    Members Viewed.......       x           Upload Byte Credit...       xk.
    Error Viewing File...       x         TEST Executed..........       x
  LIB Executed...........       x         REPACK Executed........       x
  ASCII transfer Attempt.       x

76. Added REPORTTEXT to allow changing the text on the fixed portion of the
    reports. Changed structure of program to accommodate this.

77. Added changes from CAL14S24.ZIP to this release as follows:

    Added logic to strip the leading 'CONNECT' or 'CARRIER' from the connect
    types report. (Already had this, controlled by CONNECTFILTER, but added
    a CONNECTFILTER NEW to perform the new routine added to 14S24 instead.)

    Added logic to count opening chat doors as a "node chat".
    (If the word CHAT appears in name of the Door then it is counted as a
    Node Chat, also Added CHATDOOR to allow listing Chat Doors, and if the
    door is one in the list then it counts as a Node Chat and time spent in
    the Door counts as Node Chat Time as well as Time Spent in Door.)

    Added logic to count all (Local) connect types as sysop local sessions.
    (Added ALL_LOCAL option to control this as I didn't like the idea myself.)

    Added SUBTITLE option to allow a variable subtitle to be included in
    each report. (This prints after Systems Statistics Title on Report A.)

    Added PEAK AUTO option to automatically report the top 6 hours as the
    peak hours of the day. (added additional allowance for a numeric value
    after AUTO to determine the number of hours to flag as peak.)

78. Added UPLOADFAILED to control Verificaton Failed reducing Upload Count
    and/or User Upload Count. This allows removing report credit for uploads
    when a file fails verification.

79. Added support for additional languages. Support now includes Southern,
    Three Stooges, Star Trek, Canadian, Australian, Arnold Schwarzenneger,
    Goverment-ese, Jive & Abusive.

80. Fixed Julian Date calculation causing miscalculation of days in use (and
    hours in use). I think I finally have a routine that works (I didn't
    write the first one).

81. Added support for @Xnn code at start of text. CALLS now skips the color
    code before parsing the line. Some language file modifications have a
    color code (although I don't know why when there is a single value in
    the PCBTEXT entry that determines the color of the prompt.)

82. Added entries to Voter Plus Door, MailDoor & Security Reports.

83. Added PCBPage & Emergency Pager Door Report.

84. Added CONNECTFILTER ALL option to condense PROT: & COMP: messages to
    '/'. Under PROT: the word NONE is removed and ALT is changed to MNP
    and LAP-M is changed to V42. Under COMP: the word NONE and CLASS are
    removed and V.42BIS is changed to 'B'. All Spaces are then stripped
    from the string.  This should help reduce the number of different
    Connect messages in the report by combining entries from multiple nodes
    when different brand modems are in use and the report messages are
    different. As I see more message reported to me by Sysops, I will
    tailor these routines to get as much consistency as possible.

85. Added CONNECTFILTER HST option to condense HST type messages by removing
    ARQ, V32 and NONE and changing HST/HST to just HST. LAPM is changed to
    V42 and LAPM/V42BIS is changed to V42B.

    If you use different brands of modems on different nodes, you can use a
    CONNECTFILTER HST and CONNECTFILTER ALL to enable both filters.

86. Added BAUDFILTER to allow removing 'E' from Baud Rates to combine such
    rates as 14400 and 14400E instead of reporting seperately.

87. Found if last Node CALLER file was missing the Usage hours get messed up
    and negative idle, over 100% usage and other errors occur.

88. Added support for Caller ID (CID:) line in PCBoard 15.0 by adding CALLERID
    option.

    CALLERID 1 works with Supra 14.4/Fax #CID=1 format messages:

      CID: DATE = 0402 TIME = 2234 NMBR = 4049621788
      CID: DATE = 0402 TIME = 2236 NMBR = P
      CID: DATE = 0402 TIME = 2238 NMBR = O

    The key to this setting is the 'NMBR = ' text and the number is expected
    to follow this.

    CALLERID 2 works with ZyXEL modems:

      CID: TIME: 04-02 22:34 CALLER NUMBER: 4049621788
      CID: TIME: 04-02 22:36 REASON FOR NO CALLER NUMBER: PRIVATE
      CID: TIME: 04-02 22:38 REASON FOR NO CALLER NUMBER: OUT-OF-AREA

    The key to this setting is the 'NUMBER: ' text and the number is expected
    to follow this.

    For other modems (since I don't have them) you can set CALLERID to the
    position of the phone number on the line.  Example:

      CID: 040222344049621788
      CID: 04022236P
      CID: 04022238O

    So a setting of CALLERID 20 would be needed. The range would be 12 to
    52 in all likelyhood.

    If you have different modems on different lines and you are combining nodes
    into one report then I'll have to come up with something so let me know.

89. Added short report with Hourly Usage, Baud Rate & System Statistics
    '/' report option produces a 23 line report as follows:

                    -= Average Percent of Hourly Usage =-
       00  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23
100%                                                  
 90%                                                  
 80%                                                  
 70%                                                  
 60%                                                  
 50%                                                 
 40%                                             
 30%                                    
 20%                               
 10%                          
       00  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23
Peak:  ** **                   **             **       ** ** ** ** ** ** ** **

Baud:   300: xxx     1200: xxx     2400: xxx     9600: xxx    14400: xxx
Type:  NONE: xxx     V.42: xxx    V.42B: xxx      MNP: xxx      HST: xxx

  Total Messages Left....     xxx         Number of Callers......     xxx
  Total Operation Hours..   xxx.x           New Users Registered.     xxx
    Utilization Hours....   xxx.x           Ave. Calls Per Day...    xx.x
    Total Utilization %..    xx.x           Ave. Call Duration...    xx.x
    Peak Utilization %...    xx.x           Ave. Idle Time.......    xx.x

90. Added Return Receipt counting to message stats.

91. Added Language number check to Last On (L): line as it can not be imbedded
    into Caller Number, Caller Security or Modem in PCBoard 15.0 anymore.

92. Added File Attachment counting in Message & Transfer reports.

93. Added Configuration option for download report '*' breakpoints.
    DL_LEVEL L NN allows the breakpoint (L) to be set to a new value (NN).
    The value of L is 1-4 and NN is 1-32767.  The Default breakpoints are
    2, 6, 12 and 24 and is relative to MINDL. If MINDL is 2 (the default)
    the breakpoints would be 0-4 (none), 5-8 (*), 9-14 (**), 15-26 (***),
    and 27+ (****). Issuing DL_LEVEL 3 16 would change it to 9-18 (**) and
    19-26 (***).

94. Added (R) RIPscript mode & Unknown mode (to count any new additions
    before CALLS gets updated to recognize them) to graphics mode report.
    Added Toggled ANSI mode & Toggled RIPscript mode to User report.

95. Added some support for recognizing lines generated by a couple of
    PPE programs (Stats Viewed & SEARCH:) and error messages generated
    by PPL. I'll have to give some thought on a PPE related report that
    will be similar to the Sysop Definable Door report to allow the .CNF
    file to specify how to recognize & report the data.

96. Added recognition of "Hanging up now.  Thank you for the upload(s)."
    so CALLS will not count the current User as having dropped Carrier.
    and added "Hungup after Upload" to security report.

97. Added reporting of No Bulletins, Directories, News File, Doors or
    Conferences to Security Statistics Report

98. Fixed Event timing when PCBoard does not write the starting time out.
    Added RNET 2.00 recognition.

99. Fixed a problem reading back in a CALLS.SAV file that would lock up the
    computer, requiring a reboot. Switched to Turbo Pascal 6.0 having run
    across PROKIT34.ZIP on one of the CD-ROMS.

100. Added File/Byte Ratio exceeded report to Security Statistics Report.

101. Added Alias/Name changes report to User Statistics Report.

102. Added Report for Downloads and Uploads in Conferences. New variables
     MAXCONFDLS & MAXCONFULS control report. Also new varialble CONFERENCE0
     allows setting name of Main Board.

103. Added Report for Files Scanned in Conferences. new variable MAXCONFSCAN
     controls report.

104. Added Report for Time Spent in Conferences (requires change to PCBTEXT
     entries 328 & 412. Add ' at @SYSTIME@' to end of entries. New variable
     MAXCONFTIME controls report.

105. While testing the above additions, found and fixed a never reported
     problem in timing Doors, Drops to DOS & Chatting that crossed midnight.

106. Added Conference Reports that combines data already reported in the
     various graph sections into a sigle report for each conference that
     is specified in the CALLS.CNF file.     Up to 50 Conferences can be
     specified. New variable CONFERENCE controls report.   Note that the
     name of the conferences are case sensitive.  Main Board will always
     show Zero for Conference Joined, although I could increment it when
     a conference is abandoned, it wouldn't be accurate anyways for other
     reasons and most Sysops want this report for other conferences.

                     -= Main Board Conference Report =-

  Conference Joined......       0         Time Spent in Conf.....    9:35
  Messages Left..........       6         Files Uploaded.........       1
  Files Scanned..........      56         Files Downloaded.......      31

*---------------------------------------------------------------------------
If you know of any other problems that exist or some other data that is
not being reported that should be, let me know.  >>>>>Gary Meeker

Source code is not included, as I don't wish to distribute modified source
code, but feel other Sysops might benefit from the changes made. If you
need the source code, you can request it from me on my BBS, but I ask
that you do not upload it anywhere else.  For those wishing to compile
you will need mdosio, openshar, qread, ansicrt, dosmem & bufio TPU files
which can be found in PROKIT33.ZIP if your using Turbo Pascal 5.5 or
PROKIT34.ZIP if your using Turbo Pascal 6.0, or a later release possibly,
and if you find a later release PLEASE send it to me as 3.4 is the last
I have found, and I found ProDoor 3.5.

SHARP Technical Support Line BBS (404) 962-1788 (SupraFAX 14.4 V.32bis)

via Fax: (404) 995-0613

or via mail:

Gary Meeker
C/O SHARP Electronics Corporation
725-C Old Norcross Road
Lawrenceville, GA  30245

or I call into SaltAir regularly.
